ServerEvents.recipes(event => {
    event.remove({output: 'immersiveengineering:hammer'})
    event.remove({input: 'immersiveengineering:hammer'})
    event.remove({id: 'immersiveengineering:crafting/strip_lv'})
    event.remove({id: 'immersiveengineering:crafting/strip_mv'})
    event.remove({id: 'immersiveengineering:crafting/wire_electrum'})
    event.remove({id: 'immersiveengineering:crafting/wire_aluminum'})
    event.remove({id: 'immersiveengineering:crafting/wire_steel'})
    event.remove({id: 'immersiveengineering:crafting/wire_lead'})
    event.remove({id: 'immersiveengineering:crafting/wire_copper'})
    event.remove({id: 'immersiveengineering:crafting/cokebrick'})
    event.remove({id: 'immersiveengineering:crafting/sheetmetal_copper'})
    event.remove({id: 'immersiveengineering:crafting/sheetmetal_aluminum'})
    event.remove({id: 'immersiveengineering:crafting/sheetmetal_lead'})
    event.remove({id: 'immersiveengineering:crafting/sheetmetal_silver'})
    event.remove({id: 'immersiveengineering:crafting/sheetmetal_nickel'})
    event.remove({id: 'immersiveengineering:crafting/sheetmetal_uranium'})
    event.remove({id: 'immersiveengineering:crafting/sheetmetal_constantan'})
    event.remove({id: 'immersiveengineering:crafting/sheetmetal_electrum'})
    event.remove({id: 'immersiveengineering:crafting/sheetmetal_steel'})
    event.remove({id: 'immersiveengineering:crafting/sheetmetal_iron'})
    event.remove({id: 'immersiveengineering:crafting/sheetmetal_gold'})
    event.remove({id: 'immersiveengineering:crafting/stick_iron'})
    event.remove({id: 'immersiveengineering:crafting/stick_aluminum'})
    event.remove({id: 'immersiveengineering:crafting/blastbrick'})
    event.remove({id: 'immersiveengineering:crafting/windmill'})
    event.remove({id: 'immersiveengineering:crafting/watermill'})
    event.remove({id: 'immersiveengineering:crafting/workbench'})
    event.remove({id: 'immersiveengineering:crafting/dynamo'})
    event.remove({id: 'immersiveengineering:crafting/capacitor_mv'})
    event.remove({id: 'immersiveengineering:crafting/capacitor_hv'})
    event.remove({id: 'immersiveengineering:crafting/hemp_fabric'})
    event.remove({id: 'immersiveengineering:crafting/stick_steel'})
    event.remove({id: 'immersiveengineering:crafting/cloche'})
    event.remove({id: 'immersiveengineering:crafting/alloybrick'})
    event.remove({id: 'createaddition:compat/immersiveengineering/item_application/kiln_brick_using_deployer'})
    event.remove({id: 'createaddition:compat/immersiveengineering/item_application/kiln_brick'})
    event.remove({id: 'createaddition:compat/immersiveengineering/crushing/coal_coke'})
    event.remove({id: 'createaddition:compat/immersiveengineering/crushing/coke_block'})
    event.remove({id: 'immersiveengineering:crafting/steel_scaffolding_standard'})
    event.remove({id: 'immersiveengineering:crafting/heavy_engineering'})
    event.remove({id: 'immersiveengineering:crafting/light_engineering'})
    event.remove({id: 'immersiveengineering:crafting/rs_engineering'})
    event.remove({id: 'immersiveengineering:crafting/generator'})
    event.remove({id: 'immersiveengineering:crafting/radiator'})
    event.remove({id: 'immersivepaintings:painting'})
    event.remove({id: 'createaddition:rolling/steel_ingot'})
    event.remove({id: 'createaddition:rolling/iron_ingot'})
})

ServerEvents.recipes(event => {
    //Hammer
      event.shaped('immersiveengineering:hammer',
        [' 12','431','35 '], {
          1: '#forge:ingots/iron', 
          2: 'create:precision_mechanism',
          3: 'create:shaft',
          4: 'hexerei:wax_blend',
          5: 'hexerei:infused_fabric'
      }).id('immersiveengineering:hammer')

      //Steel Rod
      event.recipes.create.milling('#forge:rods/steel', '#forge:ingots/steel').id('create:milling/steel_rod')

      //Iron Rod
      event.recipes.create.milling('#forge:rods/iron', '#forge:ingots/iron').id('create:milling/iron_rod')
      
      //Sheetmetal Copper
        event.shaped('immersiveengineering:sheetmetal_copper',
          [' 1 ','1 1',' 1 '], {
            1: '#forge:plates/copper'
        }).id('immersiveengineering:sheetmetal_copper')
      
      //Sheetmetal Aluminum
        event.shaped('immersiveengineering:sheetmetal_aluminum',
          [' 1 ','1 1',' 1 '], {
            1: '#forge:plates/aluminum'
        }).id('immersiveengineering:sheetmetal_aluminum')
      
      //Sheetmetal Lead
        event.shaped('immersiveengineering:sheetmetal_lead',
          [' 1 ','1 1',' 1 '], {
            1: '#forge:plates/lead'
        }).id('immersiveengineering:sheetmetal_lead')
      
      //Sheetmetal Silver
        event.shaped('immersiveengineering:sheetmetal_silver',
          [' 1 ','1 1',' 1 '], {
            1: '#forge:plates/silver'
        }).id('immersiveengineering:sheetmetal_silver')
      
      //Sheetmetal Nickel
        event.shaped('immersiveengineering:sheetmetal_nickel',
          [' 1 ','1 1',' 1 '], {
            1: '#forge:plates/nickel'
        }).id('immersiveengineering:sheetmetal_nickel')
      
        //Sheetmetal Uranium
          event.shaped('immersiveengineering:sheetmetal_uranium',
            [' 1 ','1 1',' 1 '], {
              1: '#forge:plates/uranium'
          }).id('immersiveengineering:sheetmetal_uranium')
      
      //Sheetmetal Constantan
        event.shaped('immersiveengineering:sheetmetal_constantan',
          [' 1 ','1 1',' 1 '], {
            1: '#forge:plates/constantan'
        }).id('immersiveengineering:sheetmetal_constantan')
      
      //Sheetmetal Electrum
        event.shaped('immersiveengineering:sheetmetal_electrum',
          [' 1 ','1 1',' 1 '], {
            1: '#forge:plates/electrum'
        }).id('immersiveengineering:sheetmetal_electrum')
      
      //Sheetmetal Steel
        event.shaped('immersiveengineering:sheetmetal_steel',
          [' 1 ','1 1',' 1 '], {
            1: '#forge:plates/steel'
        }).id('immersiveengineering:sheetmetal_steel')
      
      //Sheetmetal Iron
        event.shaped('immersiveengineering:sheetmetal_iron',
          [' 1 ','1 1',' 1 '], {
            1: '#forge:plates/iron'
        }).id('immersiveengineering:sheetmetal_iron')
      
        //Sheetmetal Gold
          event.shaped('immersiveengineering:sheetmetal_gold',
            [' 1 ','1 1',' 1 '], {
              1: '#forge:plates/gold'
          }).id('immersiveengineering:sheetmetal_gold')
      
      //Windmill
        event.shaped('immersiveengineering:windmill',
          ['111','121','111'], {
            1: 'immersiveengineering:windmill_blade',
            2: 'create:windmill_bearing'
        }).id('immersiveengineering:windmill')
      
      //Water Wheel
        event.shaped('immersiveengineering:watermill',
          ['111','121','111'], {
            1: 'immersiveengineering:waterwheel_segment',
            2: 'create:large_water_wheel'
        }).id('immersiveengineering:watermill')
      
      //Engineer's Workbench
        event.shaped('immersiveengineering:workbench',
          ['   ','122','4 3'], {
            1: '#forge:ingots/steel',
            2: '#forge:treated_wood_slab',
            3: 'immersiveengineering:treated_fence',
            4: 'immersiveengineering:craftingtable'
        }).id('immersiveengineering:workbench')
      
      //Kinetic Dynamo
        event.shaped('immersiveengineering:dynamo',
          ['   ','121','343'], {
            1: 'minecraft:redstone',
            2: 'immersiveengineering:component_iron',
            3: '#forge:ingots/steel',
            4: 'immersiveengineering:coil_lv'
        }).id('immersiveengineering:dynamo')
      
      //MV Capacitor
        event.shaped('immersiveengineering:capacitor_mv',
          ['121','343','151'], {
            1: '#forge:treated_wood',
            2: '#forge:plates/nickel',
            3: '#forge:ingots/steel',
            4: 'immersiveengineering:capacitor_lv',
            5: '#forge:plates/iron'
        }).id('immersiveengineering:capacitor_mv')
      
      //HV Capacitor
        event.shaped('immersiveengineering:capacitor_hv',
          ['121','343','151'], {
            1: '#forge:treated_wood',
            2: '#forge:plates/aluminum',
            3: '#forge:ingots/steel',
            4: 'immersiveengineering:capacitor_mv',
            5: '#forge:ingots/hop_graphite'
        }).id('immersiveengineering:capacitor_hv')
      
      //Tough Fabric
        event.shaped('immersiveengineering:hemp_fabric',
          ['111','121','111'], {
            1: 'immersiveengineering:hemp_fiber',
            2: 'immersiveengineering:stick_treated'
        }).id('immersiveengineering:hemp_fabric')

        //Coke Brick
        event.custom({
          "type": "create:mechanical_crafting",
          "acceptMirrored": false,
          "key": {
            "A": {
              "item": "minecraft:clay_ball"
            },
            "B": {
              "item": "#forge:ingots/brick"
            },
            "C": {
              "item": "#forge:ingots/brass"
            }
          },
          "pattern": [
            "ABA",
            "BCB",
            "ABA",
          ],
          "result": {
            "count": 3,
            "item": "immersiveengineering:cokebrick"
          }
        }).id('immersiveengineering:cokebrick')
      
        //Blast Brick
        event.custom({
          "type": "create:mechanical_crafting",
          "acceptMirrored": false,
          "key": {
            "A": {
              "item": "minecraft:nether_brick"
            },
            "B": {
              "item": "#forge:ingots/brick"
            },
            "C": {
              "item": "immersiveengineering:cokebrick"
            }
          },
          "pattern": [
            "ABA",
            "BCB",
            "ABA",
          ],
          "result": {
            "count": 3,
            "item": "immersiveengineering:blastbrick"
          }
        }).id('immersiveengineering:blastbrick')
      
        //Kiln brick
        event.custom({
          "type": "create:mechanical_crafting",
          "acceptMirrored": false,
          "key": {
            "A": {
              "item": "immersiveengineering:cokebrick"
            },
            "B": {
              "item": "immersiveengineering:blastbrick"
            }
          },
          "pattern": [
            "AB",
            "BA"
          ],
          "result": {
            "count": 1,
            "item": "immersiveengineering:alloybrick"
          }
        }).id('immersiveengineering:alloybrick')
      
        //Garden Cloche
          event.shaped('immersiveengineering:cloche',
            ['121','1 1','343'], {
              1: 'mob_grinding_utils:tinted_glass',
              2: 'simplylight:illuminant_block_on',
              3: '#forge:treated_wood',
              4: 'immersiveengineering:component_steel'
          }).id('immersiveengineering:cloche')
      
        //Steel Scaffolding
          event.shaped('2x immersiveengineering:steel_scaffolding_standard',
            ['111',' 2 ','2 2'], {
              1: '#forge:ingots/steel',
              2: '#forge:rods/steel'
          }).id('immersiveengineering:steel_scaffolding_standard')
      
        //Aluminum Scaffolding
          event.shaped('2x immersiveengineering:alu_scaffolding_standard',
            ['111',' 2 ','2 2'], {
              1: '#forge:ingots/aluminum',
              2: '#forge:rods/aluminum'
          }).id('immersiveengineering:alu_scaffolding_standard')
      
        //Redstone Engineering Block
          event.shaped('2x immersiveengineering:rs_engineering',
            ['121','232','121'], {
              1: '#forge:sheetmetals/iron',
              2: 'minecraft:redstone',
              3: '#forge:ingots/steel'
          }).id('immersiveengineering:rs_engineering')
      
        //Light Engineering Block
          event.shaped('2x immersiveengineering:light_engineering',
            ['121','232','121'], {
              1: '#forge:sheetmetals/iron',
              2: 'immersiveengineering:component_iron',
              3: '#forge:ingots/brass'
          }).id('immersiveengineering:light_engineering')
      
        //Heavy Engineering Block
          event.shaped('2x immersiveengineering:heavy_engineering',
            ['121','232','121'], {
              1: '#forge:sheetmetals/steel',
              2: 'immersiveengineering:component_steel',
              3: '#forge:ingots/electrum'
          }).id('immersiveengineering:heavy_engineering')

    //Generator Block
    event.shaped('2x immersiveengineering:generator',
    ['121','232','121'], {
        1: '#forge:sheetmetals/steel',
        2: 'immersiveengineering:coil_mv',
        3: 'immersiveengineering:component_iron'
    }).id('immersiveengineering:generator')

    //Radiator Block
    event.shaped('2x immersiveengineering:radiator',
    ['121','232','121'], {
        1: '#forge:sheetmetals/steel',
        2: '#forge:plates/copper',
        3: '#forge:buckets/water'
    }).id('immersiveengineering:radiator')

    //Metal Bar
    event.shaped('immersive_paintings:painting',
    ['111','121','111'], {
      1: 'eidolon:wicked_weave',
      2: '#forge:dyes'
    }).id('immersive_paintings:painting')
})